Merge branch 'ab/tap' into maint
[git/git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
23 ;;
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
78
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
82
83 unset GREP_OPTIONS
84
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
91 ;;
92 esac
93
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
100 # Each test should start with something like this, after copyright notices:
101 #
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
114 color=t
115
116 while test "$#" -ne 0
117 do
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
126 help=t; shift ;;
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
129 -q|--q|--qu|--qui|--quie|--quiet)
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133 --with-dashes)
134 with_dashes=t; shift ;;
135 --no-color)
136 color=; shift ;;
137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138 valgrind=t; verbose=t; shift ;;
139 --tee)
140 shift ;; # was handled already
141 --root=*)
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143 shift ;;
144 *)
145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146 esac
147 done
148
149 if test -n "$color"; then
150 say_color () {
151 (
152 TERM=$ORIGINAL_TERM
153 export TERM
154 case "$1" in
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
159 *) test -n "$quiet" && return;;
160 esac
161 shift
162 printf "%s" "$*"
163 tput sgr0
164 echo
165 )
166 }
167 else
168 say_color() {
169 test -z "$1" && test -n "$quiet" && return
170 shift
171 echo "$*"
172 }
173 fi
174
175 error () {
176 say_color error "error: $*"
177 GIT_EXIT_OK=t
178 exit 1
179 }
180
181 say () {
182 say_color info "$*"
183 }
184
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
187
188 if test "$help" = "t"
189 then
190 echo "$test_description"
191 exit 0
192 fi
193
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197 exec 4>&2 3>&1
198 else
199 exec 4>/dev/null 3>/dev/null
200 fi
201
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
207
208 test_external_has_tap=0
209
210 die () {
211 code=$?
212 if test -n "$GIT_EXIT_OK"
213 then
214 exit $code
215 else
216 echo >&5 "FATAL: Unexpected exit with code $code"
217 exit 1
218 fi
219 }
220
221 GIT_EXIT_OK=
222 trap 'die' EXIT
223
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
226 #
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
230 #
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234 FAKE_EDITOR="$1"
235 export FAKE_EDITOR
236 EDITOR='"$FAKE_EDITOR"'
237 export EDITOR
238 }
239
240 test_decode_color () {
241 sed -e 's/.\[1m/<WHITE>/g' \
242 -e 's/.\[31m/<RED>/g' \
243 -e 's/.\[32m/<GREEN>/g' \
244 -e 's/.\[33m/<YELLOW>/g' \
245 -e 's/.\[34m/<BLUE>/g' \
246 -e 's/.\[35m/<MAGENTA>/g' \
247 -e 's/.\[36m/<CYAN>/g' \
248 -e 's/.\[m/<RESET>/g'
249 }
250
251 q_to_nul () {
252 perl -pe 'y/Q/\000/'
253 }
254
255 q_to_cr () {
256 tr Q '\015'
257 }
258
259 append_cr () {
260 sed -e 's/$/Q/' | tr Q '\015'
261 }
262
263 remove_cr () {
264 tr '\015' Q | sed -e 's/Q$//'
265 }
266
267 test_tick () {
268 if test -z "${test_tick+set}"
269 then
270 test_tick=1112911993
271 else
272 test_tick=$(($test_tick + 60))
273 fi
274 GIT_COMMITTER_DATE="$test_tick -0700"
275 GIT_AUTHOR_DATE="$test_tick -0700"
276 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
277 }
278
279 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
280 #
281 # This will commit a file with the given contents and the given commit
282 # message. It will also add a tag with <message> as name.
283 #
284 # Both <file> and <contents> default to <message>.
285
286 test_commit () {
287 file=${2:-"$1.t"}
288 echo "${3-$1}" > "$file" &&
289 git add "$file" &&
290 test_tick &&
291 git commit -m "$1" &&
292 git tag "$1"
293 }
294
295 # Call test_merge with the arguments "<message> <commit>", where <commit>
296 # can be a tag pointing to the commit-to-merge.
297
298 test_merge () {
299 test_tick &&
300 git merge -m "$1" "$2" &&
301 git tag "$1"
302 }
303
304 # This function helps systems where core.filemode=false is set.
305 # Use it instead of plain 'chmod +x' to set or unset the executable bit
306 # of a file in the working directory and add it to the index.
307
308 test_chmod () {
309 chmod "$@" &&
310 git update-index --add "--chmod=$@"
311 }
312
313 # Use test_set_prereq to tell that a particular prerequisite is available.
314 # The prerequisite can later be checked for in two ways:
315 #
316 # - Explicitly using test_have_prereq.
317 #
318 # - Implicitly by specifying the prerequisite tag in the calls to
319 # test_expect_{success,failure,code}.
320 #
321 # The single parameter is the prerequisite tag (a simple word, in all
322 # capital letters by convention).
323
324 test_set_prereq () {
325 satisfied="$satisfied$1 "
326 }
327 satisfied=" "
328
329 test_have_prereq () {
330 case $satisfied in
331 *" $1 "*)
332 : yes, have it ;;
333 *)
334 ! : nope ;;
335 esac
336 }
337
338 # You are not expected to call test_ok_ and test_failure_ directly, use
339 # the text_expect_* functions instead.
340
341 test_ok_ () {
342 test_success=$(($test_success + 1))
343 say_color "" "ok $test_count - $@"
344 }
345
346 test_failure_ () {
347 test_failure=$(($test_failure + 1))
348 say_color error "not ok - $test_count $1"
349 shift
350 echo "$@" | sed -e 's/^/# /'
351 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
352 }
353
354 test_known_broken_ok_ () {
355 test_fixed=$(($test_fixed+1))
356 say_color "" "ok $test_count - $@ # TODO known breakage"
357 }
358
359 test_known_broken_failure_ () {
360 test_broken=$(($test_broken+1))
361 say_color skip "not ok $test_count - $@ # TODO known breakage"
362 }
363
364 test_debug () {
365 test "$debug" = "" || eval "$1"
366 }
367
368 test_run_ () {
369 test_cleanup=:
370 eval >&3 2>&4 "$1"
371 eval_ret=$?
372 eval >&3 2>&4 "$test_cleanup"
373 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
374 echo ""
375 fi
376 return 0
377 }
378
379 test_skip () {
380 test_count=$(($test_count+1))
381 to_skip=
382 for skp in $GIT_SKIP_TESTS
383 do
384 case $this_test.$test_count in
385 $skp)
386 to_skip=t
387 break
388 esac
389 done
390 if test -z "$to_skip" && test -n "$prereq" &&
391 ! test_have_prereq "$prereq"
392 then
393 to_skip=t
394 fi
395 case "$to_skip" in
396 t)
397 say_color skip >&3 "skipping test: $@"
398 say_color skip "ok $test_count # skip $1"
399 : true
400 ;;
401 *)
402 false
403 ;;
404 esac
405 }
406
407 test_expect_failure () {
408 test "$#" = 3 && { prereq=$1; shift; } || prereq=
409 test "$#" = 2 ||
410 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
411 if ! test_skip "$@"
412 then
413 say >&3 "checking known breakage: $2"
414 test_run_ "$2"
415 if [ "$?" = 0 -a "$eval_ret" = 0 ]
416 then
417 test_known_broken_ok_ "$1"
418 else
419 test_known_broken_failure_ "$1"
420 fi
421 fi
422 echo >&3 ""
423 }
424
425 test_expect_success () {
426 test "$#" = 3 && { prereq=$1; shift; } || prereq=
427 test "$#" = 2 ||
428 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
429 if ! test_skip "$@"
430 then
431 say >&3 "expecting success: $2"
432 test_run_ "$2"
433 if [ "$?" = 0 -a "$eval_ret" = 0 ]
434 then
435 test_ok_ "$1"
436 else
437 test_failure_ "$@"
438 fi
439 fi
440 echo >&3 ""
441 }
442
443 test_expect_code () {
444 test "$#" = 4 && { prereq=$1; shift; } || prereq=
445 test "$#" = 3 ||
446 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
447 if ! test_skip "$@"
448 then
449 say >&3 "expecting exit code $1: $3"
450 test_run_ "$3"
451 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
452 then
453 test_ok_ "$2"
454 else
455 test_failure_ "$@"
456 fi
457 fi
458 echo >&3 ""
459 }
460
461 # test_external runs external test scripts that provide continuous
462 # test output about their progress, and succeeds/fails on
463 # zero/non-zero exit code. It outputs the test output on stdout even
464 # in non-verbose mode, and announces the external script with "# run
465 # <n>: ..." before running it. When providing relative paths, keep in
466 # mind that all scripts run in "trash directory".
467 # Usage: test_external description command arguments...
468 # Example: test_external 'Perl API' perl ../path/to/test.pl
469 test_external () {
470 test "$#" = 4 && { prereq=$1; shift; } || prereq=
471 test "$#" = 3 ||
472 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
473 descr="$1"
474 shift
475 if ! test_skip "$descr" "$@"
476 then
477 # Announce the script to reduce confusion about the
478 # test output that follows.
479 say_color "" "# run $test_count: $descr ($*)"
480 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
481 # to be able to use them in script
482 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
483 # Run command; redirect its stderr to &4 as in
484 # test_run_, but keep its stdout on our stdout even in
485 # non-verbose mode.
486 "$@" 2>&4
487 if [ "$?" = 0 ]
488 then
489 if test $test_external_has_tap -eq 0; then
490 test_ok_ "$descr"
491 else
492 say_color "" "# test_external test $descr was ok"
493 test_success=$(($test_success + 1))
494 fi
495 else
496 if test $test_external_has_tap -eq 0; then
497 test_failure_ "$descr" "$@"
498 else
499 say_color error "# test_external test $descr failed: $@"
500 test_failure=$(($test_failure + 1))
501 fi
502 fi
503 fi
504 }
505
506 # Like test_external, but in addition tests that the command generated
507 # no output on stderr.
508 test_external_without_stderr () {
509 # The temporary file has no (and must have no) security
510 # implications.
511 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
512 stderr="$tmp/git-external-stderr.$$.tmp"
513 test_external "$@" 4> "$stderr"
514 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
515 descr="no stderr: $1"
516 shift
517 say >&3 "# expecting no stderr from previous command"
518 if [ ! -s "$stderr" ]; then
519 rm "$stderr"
520
521 if test $test_external_has_tap -eq 0; then
522 test_ok_ "$descr"
523 else
524 say_color "" "# test_external_without_stderr test $descr was ok"
525 test_success=$(($test_success + 1))
526 fi
527 else
528 if [ "$verbose" = t ]; then
529 output=`echo; echo "# Stderr is:"; cat "$stderr"`
530 else
531 output=
532 fi
533 # rm first in case test_failure exits.
534 rm "$stderr"
535 if test $test_external_has_tap -eq 0; then
536 test_failure_ "$descr" "$@" "$output"
537 else
538 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
539 test_failure=$(($test_failure + 1))
540 fi
541 fi
542 }
543
544 # This is not among top-level (test_expect_success | test_expect_failure)
545 # but is a prefix that can be used in the test script, like:
546 #
547 # test_expect_success 'complain and die' '
548 # do something &&
549 # do something else &&
550 # test_must_fail git checkout ../outerspace
551 # '
552 #
553 # Writing this as "! git checkout ../outerspace" is wrong, because
554 # the failure could be due to a segv. We want a controlled failure.
555
556 test_must_fail () {
557 "$@"
558 test $? -gt 0 -a $? -le 129 -o $? -gt 192
559 }
560
561 # Similar to test_must_fail, but tolerates success, too. This is
562 # meant to be used in contexts like:
563 #
564 # test_expect_success 'some command works without configuration' '
565 # test_might_fail git config --unset all.configuration &&
566 # do something
567 # '
568 #
569 # Writing "git config --unset all.configuration || :" would be wrong,
570 # because we want to notice if it fails due to segv.
571
572 test_might_fail () {
573 "$@"
574 test $? -ge 0 -a $? -le 129 -o $? -gt 192
575 }
576
577 # test_cmp is a helper function to compare actual and expected output.
578 # You can use it like:
579 #
580 # test_expect_success 'foo works' '
581 # echo expected >expected &&
582 # foo >actual &&
583 # test_cmp expected actual
584 # '
585 #
586 # This could be written as either "cmp" or "diff -u", but:
587 # - cmp's output is not nearly as easy to read as diff -u
588 # - not all diff versions understand "-u"
589
590 test_cmp() {
591 $GIT_TEST_CMP "$@"
592 }
593
594 # This function can be used to schedule some commands to be run
595 # unconditionally at the end of the test to restore sanity:
596 #
597 # test_expect_success 'test core.capslock' '
598 # git config core.capslock true &&
599 # test_when_finished "git config --unset core.capslock" &&
600 # hello world
601 # '
602 #
603 # That would be roughly equivalent to
604 #
605 # test_expect_success 'test core.capslock' '
606 # git config core.capslock true &&
607 # hello world
608 # git config --unset core.capslock
609 # '
610 #
611 # except that the greeting and config --unset must both succeed for
612 # the test to pass.
613
614 test_when_finished () {
615 test_cleanup="{ $*
616 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
617 }
618
619 # Most tests can use the created repository, but some may need to create more.
620 # Usage: test_create_repo <directory>
621 test_create_repo () {
622 test "$#" = 1 ||
623 error "bug in the test script: not 1 parameter to test-create-repo"
624 owd=`pwd`
625 repo="$1"
626 mkdir -p "$repo"
627 cd "$repo" || error "Cannot setup test environment"
628 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
629 error "cannot run git init -- have you built things yet?"
630 mv .git/hooks .git/hooks-disabled
631 cd "$owd"
632 }
633
634 test_done () {
635 GIT_EXIT_OK=t
636 test_results_dir="$TEST_DIRECTORY/test-results"
637 mkdir -p "$test_results_dir"
638 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
639
640 echo "total $test_count" >> $test_results_path
641 echo "success $test_success" >> $test_results_path
642 echo "fixed $test_fixed" >> $test_results_path
643 echo "broken $test_broken" >> $test_results_path
644 echo "failed $test_failure" >> $test_results_path
645 echo "" >> $test_results_path
646
647 if test "$test_fixed" != 0
648 then
649 say_color pass "# fixed $test_fixed known breakage(s)"
650 fi
651 if test "$test_broken" != 0
652 then
653 say_color error "# still have $test_broken known breakage(s)"
654 msg="remaining $(($test_count-$test_broken)) test(s)"
655 else
656 msg="$test_count test(s)"
657 fi
658 case "$test_failure" in
659 0)
660 # Maybe print SKIP message
661 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
662
663 if test $test_external_has_tap -eq 0; then
664 say_color pass "# passed all $msg"
665 say "1..$test_count$skip_all"
666 fi
667
668 test -d "$remove_trash" &&
669 cd "$(dirname "$remove_trash")" &&
670 rm -rf "$(basename "$remove_trash")"
671
672 exit 0 ;;
673
674 *)
675 if test $test_external_has_tap -eq 0; then
676 say_color error "# failed $test_failure among $msg"
677 say "1..$test_count"
678 fi
679
680 exit 1 ;;
681
682 esac
683 }
684
685 # Test the binaries we have just built. The tests are kept in
686 # t/ subdirectory and are run in 'trash directory' subdirectory.
687 TEST_DIRECTORY=$(pwd)
688 if test -n "$valgrind"
689 then
690 make_symlink () {
691 test -h "$2" &&
692 test "$1" = "$(readlink "$2")" || {
693 # be super paranoid
694 if mkdir "$2".lock
695 then
696 rm -f "$2" &&
697 ln -s "$1" "$2" &&
698 rm -r "$2".lock
699 else
700 while test -d "$2".lock
701 do
702 say "Waiting for lock on $2."
703 sleep 1
704 done
705 fi
706 }
707 }
708
709 make_valgrind_symlink () {
710 # handle only executables
711 test -x "$1" || return
712
713 base=$(basename "$1")
714 symlink_target=$TEST_DIRECTORY/../$base
715 # do not override scripts
716 if test -x "$symlink_target" &&
717 test ! -d "$symlink_target" &&
718 test "#!" != "$(head -c 2 < "$symlink_target")"
719 then
720 symlink_target=../valgrind.sh
721 fi
722 case "$base" in
723 *.sh|*.perl)
724 symlink_target=../unprocessed-script
725 esac
726 # create the link, or replace it if it is out of date
727 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
728 }
729
730 # override all git executables in TEST_DIRECTORY/..
731 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
732 mkdir -p "$GIT_VALGRIND"/bin
733 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
734 do
735 make_valgrind_symlink $file
736 done
737 OLDIFS=$IFS
738 IFS=:
739 for path in $PATH
740 do
741 ls "$path"/git-* 2> /dev/null |
742 while read file
743 do
744 make_valgrind_symlink "$file"
745 done
746 done
747 IFS=$OLDIFS
748 PATH=$GIT_VALGRIND/bin:$PATH
749 GIT_EXEC_PATH=$GIT_VALGRIND/bin
750 export GIT_VALGRIND
751 elif test -n "$GIT_TEST_INSTALLED" ; then
752 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
753 error "Cannot run git from $GIT_TEST_INSTALLED."
754 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
755 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756 else # normal case, use ../bin-wrappers only unless $with_dashes:
757 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
758 if ! test -x "$git_bin_dir/git" ; then
759 if test -z "$with_dashes" ; then
760 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
761 fi
762 with_dashes=t
763 fi
764 PATH="$git_bin_dir:$PATH"
765 GIT_EXEC_PATH=$TEST_DIRECTORY/..
766 if test -n "$with_dashes" ; then
767 PATH="$TEST_DIRECTORY/..:$PATH"
768 fi
769 fi
770 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
771 unset GIT_CONFIG
772 GIT_CONFIG_NOSYSTEM=1
773 GIT_CONFIG_NOGLOBAL=1
774 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
775
776 . ../GIT-BUILD-OPTIONS
777
778 if test -z "$GIT_TEST_CMP"
779 then
780 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
781 then
782 GIT_TEST_CMP="$DIFF -c"
783 else
784 GIT_TEST_CMP="$DIFF -u"
785 fi
786 fi
787
788 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
789 export GITPERLLIB
790 test -d ../templates/blt || {
791 error "You haven't built things yet, have you?"
792 }
793
794 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
795 then
796 GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
797 export GITPYTHONLIB
798 test -d ../git_remote_helpers/build || {
799 error "You haven't built git_remote_helpers yet, have you?"
800 }
801 fi
802
803 if ! test -x ../test-chmtime; then
804 echo >&2 'You need to build test-chmtime:'
805 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
806 exit 1
807 fi
808
809 # Test repository
810 test="trash directory.$(basename "$0" .sh)"
811 test -n "$root" && test="$root/$test"
812 case "$test" in
813 /*) TRASH_DIRECTORY="$test" ;;
814 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
815 esac
816 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
817 rm -fr "$test" || {
818 GIT_EXIT_OK=t
819 echo >&5 "FATAL: Cannot prepare test area"
820 exit 1
821 }
822
823 test_create_repo "$test"
824 # Use -P to resolve symlinks in our working directory so that the cwd
825 # in subprocesses like git equals our $PWD (for pathname comparisons).
826 cd -P "$test" || exit 1
827
828 this_test=${0##*/}
829 this_test=${this_test%%-*}
830 for skp in $GIT_SKIP_TESTS
831 do
832 case "$this_test" in
833 $skp)
834 say_color skip >&3 "skipping test $this_test altogether"
835 skip_all="skip all tests in $this_test"
836 test_done
837 esac
838 done
839
840 # Provide an implementation of the 'yes' utility
841 yes () {
842 if test $# = 0
843 then
844 y=y
845 else
846 y="$*"
847 fi
848
849 while echo "$y"
850 do
851 :
852 done
853 }
854
855 # Fix some commands on Windows
856 case $(uname -s) in
857 *MINGW*)
858 # Windows has its own (incompatible) sort and find
859 sort () {
860 /usr/bin/sort "$@"
861 }
862 find () {
863 /usr/bin/find "$@"
864 }
865 sum () {
866 md5sum "$@"
867 }
868 # git sees Windows-style pwd
869 pwd () {
870 builtin pwd -W
871 }
872 # no POSIX permissions
873 # backslashes in pathspec are converted to '/'
874 # exec does not inherit the PID
875 ;;
876 *)
877 test_set_prereq POSIXPERM
878 test_set_prereq BSLASHPSPEC
879 test_set_prereq EXECKEEPSPID
880 ;;
881 esac
882
883 test -z "$NO_PERL" && test_set_prereq PERL
884 test -z "$NO_PYTHON" && test_set_prereq PYTHON
885
886 # test whether the filesystem supports symbolic links
887 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
888 rm -f y